select
  ' ' as "Regio Gerar"
  ,' ' as "Ano Gerar"
  ,' ' as "Tcnico"
  , mun.uf as "Estado"
  , mun.municipio as "Municpio"
  , faz.nome as "Fazenda"
  -- Removido no dia 29/01/2020 ,'IA' as "Tcnica"
  , an.numero as "Nmero da matriz"
  , (select grausangue from sp_calculagrausangue(ia.cdanimal)) as "Raa da matriz"
  , (case when (an.cdcategoriainicial  = 7 and ((select count(*) from reproducao re where re.cdanimal = ia.cdanimal and re.data < ia.data and re.cdtiporeproducao = 7) + coalesce(an.numpartoentrada, 0)) = 0) then ''
          when ((select count(*) from reproducao re where re.cdanimal = ia.cdanimal and re.data < ia.data and re.cdtiporeproducao = 7) + coalesce(an.numpartoentrada, 0)) = 0 then 'Novilha'
          when ((select count(*) from reproducao re where re.cdanimal = ia.cdanimal and re.data < ia.data and re.cdtiporeproducao = 7) + coalesce(an.numpartoentrada, 0)) = 1 then 'Primpara' 
          when ((select count(*) from reproducao re where re.cdanimal = ia.cdanimal and re.data < ia.data and re.cdtiporeproducao = 7) + coalesce(an.numpartoentrada, 0)) > 1 then 'Multpara' 
          else null end)
          as "N partos"
  , (case when (cat.cdcategoria = 6) then an.dtnascimento else null end) as "Data de Nascimento - Novilhas"
  , ultpar.data as "Data de parto"
  , (case ultpar.retencaoplacenta when 1 then '1' when 0 then '0' else null end) as "Reteno de placenta"
  , anp.ccs as "CCS no Primeiro Ms Ps Parto"
  , ia.data as "Data IA/IATF"
  , coalesce((select first 1 re.pesototal from leite re where re.cdanimal = ia.cdanimal and re.dtleite >= (ia.data - 30) and re.dtleite <= ia.data
       order by re.dtleite desc),
   (select first 1 re.pesototal from leite re where re.cdanimal = ia.cdanimal and re.dtleite <= (ia.data + 30) and re.dtleite >= ia.data
       order by re.dtleite asc)) as "Produo de Leite" 
  , coalesce((select first 1 re.ccs from analiseleite re where re.cdanimal = ia.cdanimal and re.dtanaliseleite >= (ia.data - 30) and re.dtanaliseleite <= ia.data
        order by re.dtanaliseleite desc),
    (select first 1 re.ccs from analiseleite re where re.cdanimal = ia.cdanimal and re.dtanaliseleite <= (ia.data + 30) and re.dtanaliseleite >= ia.data
        order by re.dtanaliseleite asc)) as "CCS"
  , (select first 1 re.valor from medida re where re.cdanimal = ia.cdanimal and re.cdtipomedida = 2 and re.dtmedida >= (ia.data - 15)
        and re.dtmedida <= (ia.data + 15) order by re.dtmedida desc) as "ECC Inicial"
  , (case when (ia.condicaoia <> 'I') then 'Cio' else 'IATF' end) as "IATF ou Cio"
  , (select count(*) from reproducao re where re.cdanimal = ia.cdanimal and re.data < ia.data and re.data > coalesce(ultpar.data, '1900-01-01')
        and re.cdtiporeproducao in (1,2,3)) as "N IA Prvia"
  , (select first 1 re.data from reproducao re where re.cdanimal = ia.cdanimal and re.data < ia.data and re.cdtiporeproducao in (1,2,3) and re.data > coalesce(ultpar.data, '1900-01-01') order by re.data desc) as "Data da IA/IATF Anterior"
  , (case when (iaant.cdreproducao is not null) then (ia.data - iaant.data) else null end) as "Intervalo entre IA"
  , (case when (upper(prot.descricao) like '%TIPO%A%') then 'A'
            when (upper(prot.descricao) like '%TIPO%B%') then 'B'
            when (upper(prot.descricao) like '%TIPO%C%') then 'C'
            else null end) as "Tipo de Protocolo"
  , (case when (upper(impl.nome) like '%CIDR%') THEN 'C'
          when (upper(impl.nome) like '%DIB%MONO%') THEN 'DM'
          when (upper(impl.nome) like '%DIB%') and (upper(impl.nome) not like '%MONO%') THEN 'D'
          else coalesce(impl.nome, paimp.nome) end) as "Dispositivo"
  , protimp.uso as "No Usos do Dispositivo"
  , (case when
        (exists (select * from reproducao re where re.cdanimal = ia.cdanimal and
                    ((re.cdresultadoexameoe in (select cdresultadoexameginecologico from resultadoexameginecologico where upper(nomeresumido) like '%CL%'))
                            or (re.cdresultadoexameod in (select cdresultadoexameginecologico from resultadoexameginecologico where upper(nomeresumido) like '%CL%'))) and re.data >= (ia.data - 17) and re.data <= ia.data))
          then '1' else '0' end) as "CL incio protocolo"
  , (case when ia.cdprogramacaoiatf is not null then (prog.dtretirada - prog.dtimplante) when ia.cdprogramacaoiatf is null then null else null end) as "Dia da Retirada do Dispositivo"
  , (case when (upper(pd7.nome) like '%CLOPROSTENOL%') THEN 'C'
          WHEN (upper(pd7.nome) like '%DINOPROST%') THEN 'D'
          ELSE PD7.NOME end) as "PGF"
  , (case ia.cio when 1 then '1' when 2 then '0' when 0 then '0' else null end) as "Cio da Retirada at a IATF"
  , (case when
            ((select count(*) from principioativo re join protocoloiatfprincipioativo ppre on ppre.cdprincipioativo = re.cdprincipioativo
                            where upper(re.nome) like 'GONADOTRO%' and ppre.dia = 0 and ppre.cdprotocoloiatf = ia.cdprotocoloiatf) > 0)
        then '1' else '0' end) as "gNrh incio do protocolo"
  , (case when
           ((select count(*) from aplicacaoproduto re join produto pre on pre.cdproduto = re.cdproduto where re.cdanimal = ia.cdanimal and
                   re.dtaplicacaoproduto < ia.data and re.dtaplicacaoproduto >= (ia.data - (12*30.5)) and
                   upper(pre.nome) like '%CATTLE%MASTER%') > 0)
       then '1' else '0' end) as "Cattle Master"
  , ia.temperaturaretal as "T retal IA/IATF"
  , ia.hora as "Horrio da IA"
  , (case rep.cdtiposemen when 1 then 'C' when 2 then 'S' when 3 then 'S' else null end) as "Tipo de Smen"
  , coalesce(rep.nome, rep.nomecompleto) as "Nome do Touro"
  , (select grausangue from sp_calculagrausangue(rep.cdanimal)) as "Raa do Touro"
  , part.numero as "Partida do Smen"
  , ' ' as "Central do Smen"
  , pes.nome as "Inseminador" 
  , (case when (exists (select * from reproducao re where re.cdanimal = ia.cdanimal and re.data > ia.data and re.data <= (ia.data + 30)
                            and re.cdtiporeproducao in (1,2,3))) then '0'
          when ((cat30.cdcategoria = 1) and (prox.diagnostico = 'P')) then '1'
          when (cat30.cdcategoria = 3) then '1'
          when (cat30.cdcategoria = 4) then '0'
          when ((cat30.cdcategoria = 1) and ((prox.diagnostico is null) or (prox.diagnostico <> 'P'))) then '0'
          else null end) as "Prenhez 30 dias"
  , (case when (exists (select * from reproducao re where re.cdanimal = ia.cdanimal and re.data > ia.data and re.data <= (ia.data + 60)
                            and re.cdtiporeproducao in (1,2,3))) then '0'
          when ((cat60.cdcategoria = 1) and (prox.diagnostico = 'P')) then '1'
          when (cat60.cdcategoria = 3) then '1'
          when (cat60.cdcategoria = 4) then '0'
          when ((cat60.cdcategoria = 1) and ((prox.diagnostico is null) or (prox.diagnostico <> 'P'))) then '0'
          else null end) as "Prenhez 60 dias"
  , (case when
        ((exists (select * from mamite re where re.cdanimal = ia.cdanimal and re.data >= (ia.data - 30) and re.data <= (ia.data + 30)
                    and ((re.ad in (0,1,2)) or (re.ae in (0,1,2)) or (re.pd in (0,1,2)) or (re.pe in (0,1,2))))) or
        (exists (select * from doencaanimal re where re.cdanimal = ia.cdanimal and re.dtinicio > ultpar.data and re.dtinicio <= ia.data)))
          then '1' else '0' end) as "Doena na lactao"
  -- Removido no dia 29/01/2020 , (select valor from configuracao conf where conf.nome like '%PeriodoReproducaoPosParto%') as PEV
  ,' ' as "Controle de PI"
   -- Removido no dia 29/01/2020 , coalesce(ia.horaaux, ia.hora) as "EXTRA - Horrio do cio"
   -- Removido no dia 29/01/2020 , prottotal.descricao as "EXTRA - Nome do Protocolo"
   -- Removido no dia 29/01/2020 , ia.observacao as "EXTRA - Observao IA"
  , rep.numero as "EXTRA - Nmero do Touro"
   -- Removido no dia 29/01/2020 , faz.idweb as "EXTRA - Cdigo Web fazenda"
from
  fazenda faz
  join animal an on 1 = 1
  join reproducao ia on ia.cdanimal = an.cdanimal
  left join reproducao ultpar on ultpar.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.cdtiporeproducao = 7 and re.data < ia.data
        order by re.data desc)
  left join reproducao iaant on iaant.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.cdtiporeproducao in (1,2,3) and re.data >
    coalesce(ultpar.data, '1900-01-01') and re.data < ia.data order by re.data desc)
  left join protocoloiatf prot on prot.cdprotocoloiatf = ia.cdprotocoloiatf and
    ((upper(prot.descricao) like '%TIPO%A%') or (upper(prot.descricao) like '%TIPO%B%') or (upper(prot.descricao) like '%TIPO%C%'))
  left join protocoloiatf prottotal on prottotal.cdprotocoloiatf = ia.cdprotocoloiatf
  left join protocoloiatfprincipioativo protpa on protpa.cdprotocoloiatfprincipioativo =
    (select first 1 re.cdprotocoloiatfprincipioativo from protocoloiatfprincipioativo re join principioativo repa on repa.cdprincipioativo
        = re.cdprincipioativo and upper(repa.nome) = 'PROGESTERONA' where re.cdprotocoloiatf = prot.cdprotocoloiatf order by re.uso asc)
  left join animal rep on rep.cdanimal = ia.cdreprodutor
  left join pessoa pes on pes.cdpessoa = ia.cdpessoa
  join categoria cat on cat.cdcategoria = an.cdcategoria
  join categoria cat30 on cat30.cdcategoria =
    (select creprodutiva from sp_categoriaanimal((ia.data + 30), 'cdanimal = ' || ia.cdanimal))
  join categoria cat60 on cat60.cdcategoria =
    (select creprodutiva from sp_categoriaanimal((ia.data + 60), 'cdanimal = ' || ia.cdanimal))
  left join reproducao prox on prox.cdreproducao =
    (select first 1 re.cdreproducao from reproducao re where re.cdanimal = ia.cdanimal and re.data > ia.data and
        ((re.cio in (1,2)) or (re.diagnostico is not null) or (re.cdtiporeproducao in (1,2,3,7))) order by re.data asc)
  left join municipio mun on faz.cdmunicipio = mun.cdmunicipio
  left join analiseleite anp on anp.cdanaliseleite =
    (select first 1 re.cdanaliseleite from analiseleite re where re.cdanimal = an.cdanimal and re.ccs is not null and re.dtanaliseleite > ultpar.data
        and re.dtanaliseleite < (ultpar.data + 30) order by re.dtanaliseleite asc)
  left join loteproduto part on ia.cdloteproduto = part.cdloteproduto
  -----
  left join protocoloiatfprincipioativo protimp on protimp.cdprotocoloiatfprincipioativo = 
  (select first 1 re.cdprotocoloiatfprincipioativo from protocoloiatfprincipioativo re where re.cdprotocoloiatf = prot.cdprotocoloiatf and re.dia = '0' and re.cdprincipioativo in (select re1.cdprincipioativo from principioativo re1 where upper(nome) like '%PROGESTERONA%'))
  left join protocoloiatfprincipioativo d7 on d7.cdprotocoloiatfprincipioativo = 
  (select first 1 re.cdprotocoloiatfprincipioativo from protocoloiatfprincipioativo re where re.cdprotocoloiatf = prot.cdprotocoloiatf and re.dia = '7')
  left join produto impl on impl.cdproduto = protimp.cdproduto
  left join principioativo paimp on paimp.cdprincipioativo = protimp.cdprincipioativo
  left join programacaoiatf prog on prog.cdprogramacaoiatf = ia.cdprogramacaoiatf
  left join principioativo pd7 on pd7.cdprincipioativo = d7.cdprincipioativo
where
  ia.cdtiporeproducao = 1
    --- INFORME, AQUI, O PERODO DESEJADO. MANTENHA AS ASPAS SIMPLES E O FORMATO AAAA-MM-DD.
  and ia.data between '1900-01-01' and '2030-01-01'
order by
  an.numordenado